module PasReal;

{-----------------------------------------------------------------------------
{
{     PasReal -  Scott L. Brown     Created: 25-Nov-81
{     Copyright (C) 1981 - Three Rivers Computer Corporation 
{ 
{ Abstract:
{
{     PasReal is an extra character input module of the Stream package.
{     Its routines are called by code generated by the Pascal compiler 
{     in response to variations on Read, Readln, Write and Writeln 
{     statements. It is one level above Module Stream and uses Stream's
{     lower-level input routines.
{
{-----------------------------------------------------------------------------}


{-----------------------------------------------------------------------------
{
{ ChangeLog:
{
{ 26-jan-82  V0.1a  Scott L. Brown
{ Modified to raise the exception NotReal instead of NotNumber (in ReadR).
{
{ 25-Nov-81  V0.0   Scott L. Brown
{ Creation of real read and write routines ReadR and WriteR.
{
{-----------------------------------------------------------------------------}


exports

 imports Stream from Stream;

 

 procedure ReadR(var F: FileType;
                 var value: real);

 procedure WriteR(var F: FileType;
                      e: real;
                      TotalWidth: integer;
                      FracDigits: integer;
                      format: integer);


private
