Module UtilProgress;
{-----------------------------------
{
{ Progress Reporting Routines
{ Copyright (C) 1981  Three Rivers Computer Corporation
{
{ Abstract:
{    Routines to show progress of utilities.
{
{------------------------------------}

{  18 Jan 82 1.16  Brad Myers
{  Busy cursor bounce off borders.
{  Start progress at top.
{  QuitProgress set function.
{  Normal progress ignore window boundary.
{  Use time to initialize Busy.
{ }

{   6 Jan 82 1.15  Brad Myers
{  Keep busy cursor in window.
{ }

{  29-Dec-81 1.14  Brad Myers
{  Add busy procedures for when busy but don't know how long until done.
{ }

{   2-Dec-81 1.13  John Strait
{  1) Use type Long instead of FSBit32 from Arith.
{  2) Reset default cursor in QuitProgress.
{ }

{  28-Sep-81 1.12  John Strait
{  Use long arithmetic in a new routine so that when the number of steps
{  is larger than 1024 we can show finer grain.
{ }

{  31-Aug-81 1.11  John Strait
{  Show finer grain for Stream files.  This means that UtilProgress now
{  uses long arithmetic.
{ }

{  31-Aug-81 1.10  John Strait
{  Add stuff to show progress reading Stream files.
{ }

{  19-May-81 1.9  Brad Myers
{  New IO module name.
{ }

{  9-Mar-81 1.8  Don Scelza
{  Changed module name and added code to 
{  allow the user to specify the number of scan lines.
{ }

{ 20-Feb-81 1.7  Brad A. Myers 
{ New cursor
{ }

{  2-Jan-81  1.6  Miles A. Barel
{ Initial Creation
{ }

Exports
    Procedure LoadCurs;
    Procedure ShowProgress(NumLines: Integer);
    Procedure QuitProgress;
    Procedure StreamProgress( var F: File );
    Procedure ComputeProgress( Current, Max: Integer );
    Procedure LoadBusy;

Private
